﻿Type=Class
Version=2.52
@EndOfDesignText@
'Class module
Private Sub Class_Globals
	Private pnl As Panel 	
	Private Eventname As String 
	Private module As Object 
	Private tmr As Timer 
	
	Private timestep As Long 
	Private sizestep As Int
	
	Private finalHeight As Int 
	Private direction As Int 
	
	'AutoExpand
	Public maxHeight As Int 
	Public minHeight As Int
End Sub

'Initializes the Expandable Panels
'EventName only supports panel click for now
'Module is the activity name
'If you want to re-adjust otherviews, create a sub called "Resize_Views" in module that re-adjusts surrounding views
Public Sub Initialize(pEventname As String, pModule As Object)
	module    = pModule
	Eventname = pEventname
	pnl.Initialize("pnl")
End Sub

'Sets the speed of the animation
'Timestep defines the timer duration, smaller numbers = faster
'SizeStep defines the size change, smaller numbers = smoother but slower
Public Sub setSpeed(pTimestep As Long, pSizestep As Int)
	tmr.Initialize("tmr",pTimestep)
	timestep = pTimestep
	sizestep = pSizestep
End Sub

'Returns the panel
Public Sub AsPanel As Panel
	Return pnl
End Sub

'Dynamically resize panel to required height
'Make sure to set setSpeed before calling Resize
Public Sub ResizeTo(pfinalHeight As Int)
	finalHeight = pfinalHeight
	If pnl.Height > pfinalHeight Then
		direction = -1
	Else
		direction = 1
	End If
	tmr.Enabled = True
End Sub

Private Sub tmr_Tick
	pnl.Height = pnl.Height + (direction * sizestep)
	If direction = -1 Then
		If pnl.Height <= finalHeight Then
			pnl.Height = finalHeight
			tmr.Enabled = False
		End If
	Else
		If pnl.Height >= finalHeight Then
			pnl.Height = finalHeight
			tmr.Enabled = False
		End If
	End If
	CallSub2(module,Eventname &  "_Resize",Me)
End Sub

Private Sub pnl_Click
	CallSub2(module,Eventname & "_Click",Me)
End Sub

'Resizes the panel to maxHeight. Make sure to set it before you call Expand
Public Sub Expand
	ResizeTo(maxHeight)
End Sub

'Resizes the panel to minHeigh. Make sure to set it before you call Collapse
Public Sub Collapse
	ResizeTo(minHeight)
End Sub

'Returns whether the panel is fully expanded or not
'Depends on maxHeight and minHeight being set
Public Sub IsExpanded As Boolean
	Return (pnl.Height = maxHeight)
End Sub

'Toggles the height to expand or collapse.
'Make sure maxHeight AND minHeight As set
Public Sub ToggleHeight
	If IsExpanded Then
		Collapse
	Else
		Expand
	End If
End Sub

